/* -*- mode: c++; c-basic-offset: 2; indent-tabs-mode: nil; -*- */
#ifndef DISKCAHCE__TCL_HH
#define DISKCAHCE__TCL_HH

#include <algorithm>
#include <iostream>
#include <iterator>
#include <list>
#include <string>
#include <sstream>

#include "general/types.hh"

namespace diskCache
{
  namespace TCL
  {
    template< typename OUT, typename CONST_ITERATOR >
    void List( OUT& Output, CONST_ITERATOR Cur, CONST_ITERATOR Stop );

    template< typename OUT, typename CONST_ITERATOR >
    void ListUnbounded( OUT& Output, CONST_ITERATOR Cur, CONST_ITERATOR Stop );

    template<typename OUT>
    void Parse(const CHAR* Input, OUT& Output );

    template<> inline
    void Parse( const CHAR* Input, std::list< std::string >& Output )
    {
      std::istringstream	in( Input );
      Output.erase( Output.begin( ),
		    Output.end( ) );
      std::copy( std::istream_iterator< std::string >( in ),
		 std::istream_iterator< std::string >( ),
		 std::back_inserter( Output ) );
    }

    template<typename OUT, typename IN>
    void Translate( OUT& Output, const IN& Input );
  }
}
#endif /* DISKCAHCE__TCL_HH */

